/* This file can be redistributed and used under GNU Library General Public
 * License. (c) 2000 Micha Moskal <malekith@topnet.pl>. 
 * $Id: colorset.cc,v 1.9 2000/09/09 17:59:14 malekith Exp $ */

#define _V_PRIVATE
#include <v/v.h>
#include <v/term.h>
#include <v/hash.h>

ColorSet *v_default_colorset; 

static ColorSetInit default_colors[] = {
{ "normal",				COLOR(LIGHTGRAY, BLACK) },
{ "background",				COLOR(LIGHTGRAY, BLACK) },
{ "win_frame",				COLOR(CYAN, BLACK) },
{ "win_frame_active",			COLOR(LIGHTCYAN, BLACK) },
{ "win_title",				COLOR(LIGHTGRAY, BLACK) },
{ "win_title_active",			COLOR(WHITE, BLACK) },
{ "button",				COLOR(GREEN, BLACK) },
{ "button_active",			COLOR(BLACK, GREEN) },
{ "button_hl",				COLOR(LIGHTGREEN, BLACK) },
{ "button_hl_active",			COLOR(LIGHTGREEN, GREEN) },
{ "label",				COLOR(LIGHTGRAY, BLACK) },
{ "text_area",				COLOR(LIGHTGRAY, BLACK) },
{ "listitem_normal",			COLOR(LIGHTGRAY, BLUE) },
{ "listitem_selected",			COLOR(BLACK, CYAN) },
{ "listitem_hl_normal",			COLOR(YELLOW, BLUE) },
{ "listitem_hl_selected",		COLOR(YELLOW, CYAN) },
{ "inputline_normal",			COLOR(BLACK, CYAN) },
{ "inputline_selected",			COLOR(WHITE, CYAN) },
{ "inputline_arrow",			COLOR(YELLOW, GREEN) },
{ "inputline_deadly",			COLOR(WHITE, BLUE) },
{ "inputline_ghosted",			COLOR(WHITE, BLACK) },
{ "menubar_normal",			COLOR(BLACK, CYAN) },
{ "menubar_hl_normal",			COLOR(LIGHTCYAN, CYAN) },
{ "menubar_selected",			COLOR(CYAN, BLACK) },
{ "menubar_hl_selected",		COLOR(LIGHTCYAN, BLACK) },
{ "menu_normal",			COLOR(CYAN, BLACK) },
{ "menu_hl_normal",			COLOR(LIGHTCYAN, BLACK) },
{ "menu_selected",			COLOR(BLACK, CYAN) },
{ "menu_hl_selected",			COLOR(LIGHTCYAN, CYAN) },
{ "status_normal",			COLOR(BLACK, LIGHTGRAY) },
{ "status_hl",				COLOR(RED, LIGHTGRAY) },
{ "pbar_frame",				COLOR(BLUE, BLACK) },
{ "pbar_fill",				COLOR(BROWN, BROWN) },
{ "pbar_empty",				COLOR(CYAN, CYAN) },
{ 0, 0 }
};

void ColorSet::init()
{
	v_default_colorset = ColorSet::make(default_colors);
}

int ColorSet::get_color(const String &name)
{
	return ((Hash<int>*)hash_p)->get(name);
}

ColorSet::~ColorSet()
{
	delete (Hash<int>*)hash_p;
}

ColorSet *ColorSet::make(ColorSetInit *p)
{
	Hash<int> *h = new Hash<int>(COLOR(LIGHTGRAY, BLACK));
	ColorSet *r;
	
	if (v_default_colorset)
		*h = *((Hash<int>*)v_default_colorset->hash_p);
	
	while (p->name) {
		h->put(p->name, p->color);
		p++;
	}
	r = new ColorSet((void*)h);
	return r;
}

