/* This file can be redistributed and used under GNU Library General Public
 * License. (c) 2000 Micha Moskal <malekith@topnet.pl>. 
 * $Id: listbox.h,v 1.7 2000/09/09 17:59:14 malekith Exp $ */

#ifndef _V_LISTBOX_H
#define _V_LISTBOX_H

#include <v/block.h>

class ListBox;

class ListItem : public Object {
public:
	String caption;
	bool hl;
	
	virtual void execute(ListBox *) { }
	virtual void draw_at(int x, int y, int w, int col, int col2, 
			     ListBox *parent, int offset);
	ListItem(const String &cap = "") 
		: caption(cap), hl(false) 
		{ name = "ListItem"; }
};
	
class ListBox : public Widget {
public:
	Block <ListItem*> items;
	int active_item, top_item;
	int offset;	/* horizontal */
	
	virtual void draw();
	virtual void handle_event(Event &e);
	void free();
	~ListBox();
	ListBox() : active_item(0), top_item(0), offset(0) 
		{ name = "ListBox"; }
};


#endif /* _V_LISTBOX_H */
